package poly;

public class Target{
	public static int TERMINATED=-1; // signal for a terminated Target
	public static int ACTIVE=0;	// signal for an active Target

	public int stopped=ACTIVE;	// shows how many entities want to delay it

	public Task task=null;	// a chain of tasks

	public Target(Task T) throws PolyException{
		task=T;

		if (Poly.tg_count>=Poly.MAX_TARGETS){
			throw new PolyException("too many targets");
		}

		Poly.targets[Poly.tg_count++]=this;
	}

	public boolean can_exec(){
		return (stopped==ACTIVE && 
			 (task==null ||
			  (task!=null && task.can_exec())
			 )
			);
	}

	public boolean exec() throws PolyException{
		if (!can_exec()){
			throw new PolyException("an attempt to execute a frozen task");
		}

		if (task!=null){
			task=task.exec(this);
		}

		if (task==null){
			stopped=TERMINATED;	// everything is done
		}

		return true;
	}

	public int min_lines(){
	// count of lines this target will produce at minimum
		int l=0;	// lines

		Task t=task;
		while (t!=null){
			l+=t.min_lines();
			t=t.next;
		}

		return l;
	}
}
