package utils.tools.signaturesearch;

public class VirBase{
	public int cursor;
	public byte [] file;

	public VirBase(byte [] fil){
		file=fil;
		cursor=0;
	}

	public boolean eof(){
		return cursor>=file.length;
	}

	public int skip_spaces(){
		// skips spaces and returns number of skipped bytes
		int cur=cursor;
		for (; !eof() && (file[cursor]==' ' || file[cursor]=='\t'|| file[cursor]=='\n'|| file[cursor]=='\r'); cursor++);

		return cursor-cur;
	}

	public String read_word(){
		skip_spaces();

		int cur=cursor;
		for (; !eof() && !(file[cursor]==' ' || file[cursor]=='\t'|| file[cursor]=='\n'|| file[cursor]=='\r'); cursor++);

		return new String (file, cur, cursor-cur);
	}


	private int is_digit(int a){
		int result = -1;
		a=a & 0xff;
		if (a>='0' && a<='9'){
			result = a-'0';
		}

		if (a>='a' && a<='f'){
			result = a-'a'+10;
		}

		if (a>='A' && a<='F'){
			result = a-'A'+10;
		}

		return result;
	}

	public byte [] read_bytes(){
		int cur=cursor;
		byte [] result=new byte[0];

there:
		while (!eof()){
			int c = cursor;
			String w = read_word();

			for (int j=0; j<w.length(); j++)
				if (is_digit(w.charAt(j))<0){
					cursor=c;
					break there;
				};

			// yep, this is a number

			boolean odd=true;
			int b=-1;
			int b1;
			for (int i=w.length(); i-->0; ){
				b1=is_digit(w.charAt(i));

				if (odd){
					b=b1;
					b1=0;
				}

				if (!odd || i<=0){
					byte [] r = new byte[result.length+1];
					int j;
					for (j=0; j<result.length; j++)
						r[j]=result[j];

					r[j]=(byte)((b+(b1 << 4)) & 0xff);
					result=r;
				}

				odd^=true;
			}

		};

		return result;
	}

	public int read_int(){
		byte [] number = read_bytes();

		int result = 0;

		for (int i=0, m=1; i<number.length && i<4; i++){
			result+=(number[i] & 0xff) << (8*i);
		}

		return result;
	}

	public void assert(String assertion) throws Exception{
		assert(read_word(), assertion);
	}

	public void assert(String word, String assertion) throws Exception{
		if (!word.equals(assertion)){
			throw new Exception("virus base is corrupt: '"+assertion+"' expected, but '"+word+"' found");
		}
	}
}

